%Convert the .net file to ascii files.

%Peter Wintoft 2000-11-08.

%Open input file.
fid=fopen('SumKpNetwork.net','r');

%Get the number of layers.
numOfLayers = fread(fid,1,'int');

%Go through the layers and get the weights and biases.
for i=1:numOfLayers

  %Get number of rows and cols.
  l{i}.r = fread(fid,1,'int');
  l{i}.c = fread(fid,1,'int');
  
  %Get weights.
  l{i}.w = fread(fid,[l{i}.r,l{i}.c],'double');
  
  %Get biases.
  l{i}.b = fread(fid,l{i}.r,'double');
  
  %Get transfer function type.
  % 0 = purelin.
  % 1 = logsig.
  % 2 = tansig.
  l{i}.tf = fread(fid,1,'int');
  
end

%Close input file.
fclose(fid);

%Save layer 1 to ascii file in a format that fits saaps.ann.WeightsCreator.
layer=1;
fid=fopen('anom001l1.txt','wt');
fprintf(fid,'%2d %2d\n',l{layer}.r,l{layer}.c);
for i=1:l{layer}.r
  fprintf(fid,'%9.4f ',l{layer}.w(i,:));
  fprintf(fid,'\n%9.4f\n',l{layer}.b(i));
end
fclose(fid);

%Save layer 2 to ascii file in a format that fits saaps.ann.WeightsCreator.
layer=2;
fid=fopen('anom001l2.txt','wt');
fprintf(fid,'%2d %2d\n',l{layer}.r,l{layer}.c);
for i=1:l{layer}.r
  fprintf(fid,'%9.4f ',l{layer}.w(i,:));
  fprintf(fid,'\n%9.4f\n',l{layer}.b(i));
end
fclose(fid);

