/*
 * Input.java
 *
 * Created on August 9, 2000, 2:59 PM
 */
 
package saaps.ann;

import java.util.Vector;
import java.io.Serializable;
/** 
 */
public class DataNorm extends Object implements Serializable {
    
    //The minimum input values.
    private double[] inMin;
    
    //The maximum input values.
    private double[] inMax;
    
    //The minimum output values.
    private double[] outMin;
    
    //The maximum output values.
    private double[] outMax;
    
    //The input range.
    private double[] inRange;
    
    //The output range.
    private double[] outRange;
    
    /////////////////////////////////////////
    // Constructors
    /////////////////////////////////////////
    
    public DataNorm(double[] inMin, double[] inMax, double[] outMin, double[] outMax) {
        int n = inMin.length;
        this.inMin = new double[n];
        this.inMax = new double[n];
        this.outMin = new double[n];
        this.outMax = new double[n];
        this.inRange = new double[n];
        this.outRange = new double[n];
        for (int i=0;i<n;i++) {
            this.inMin[i] = inMin[i];
            this.inMax[i] = inMax[i];
            this.outMin[i] = outMin[i];
            this.outMax[i] = outMax[i];
            this.inRange[i] = inMax[i]-inMin[i];
            this.outRange[i] = outMax[i]-outMin[i];
        }
    }

    /////////////////////////////////////////
    // Public methods
    /////////////////////////////////////////
    
    public void normalize(Data data) {
        for (int i=0;i<data.getNumOfConnections();i++) {
            for (int j=0;j<data.getNumOfExamples();j++) {
                double normData = (data.get(i,j) - this.inMin[i])/this.inRange[i]*this.outRange[i] + this.outMin[i];
                data.set(i,j,normData);
            }
        }
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("Number of inputs: " + this.inMin.length + "\n");
        for (int n=0;n<this.inMin.length;n++) {
            buf.append("Input " + n);
            buf.append(" : in = (" + this.inMin[n] + "," + this.inMax[n] + ")");
            buf.append(" : out = (" + this.outMin[n] + "," + this.outMax[n] + ")\n");
        }
        return buf.toString();
    }
    
    /////////////////////////////////////////
    // Private methods
    /////////////////////////////////////////
    
}