/*
 * Weights.java
 *
 * Created on August 10, 2000, 10:44 AM
 */
 
package saaps.ann;

import java.util.Random;

/** 
 *
 * @author  saaps
 * @version 
 */
public class Weights extends Object {

  private double[] weights;
  private double bias;
  
  /** Creates new Weights */
  public Weights() {
  }
  
  public Weights(int n) {
    weights = new double[n];
  }
  
  public Weights(double[] w, double b)
  {
    weights = new double[w.length];
    for (int i=0;i<weights.length;i++)
      weights[i] = w[i];
    bias = b;
  }
  
  public void randomize(double min, double max) {
    Random rand = new Random();
    for (int i=0;i<weights.length;i++)
      weights[i] = rand.nextGaussian();
    bias = rand.nextGaussian();
  }
  
  public int getLength() {
    return weights.length;
  }
  
  public double[] getWeights()
  {
    return weights;
  }
  
  public double getBias()
  {
    return bias;
  }
  
  public void print()
  {
    System.out.println("Bias: " + bias);
    System.out.print("Weights: ");
    for (int conn=0;conn<weights.length;conn++)
      System.out.print(weights[conn] + " ");
    System.out.println();
  }
  
  public String toString() {
    StringBuffer buf = new StringBuffer(this.getClass().getName() + "\n");
    buf.append("w = ");
    for (int i=0;i<weights.length;i++)
      buf.append(weights[i] + " ");
    buf.append("\nb = " + bias + "\n");
    return buf.toString();
  }

}