/* 
	DataLook.java

	Title:
	Author:
	Description:	
*/

package saaps.dbt;

import java.io.*;
import java.util.*;
import java.text.*;
import java.lang.*;


public class DataLook  {

  Database dbRef;
  String useThis;

  public DataLook(String cname) {
    
    useThis = cname;
    dbRef = Database.getInstance(useThis,true);
  }

  // Main entry point
  static public void main(String[] args) {

    if(args.length<4) {
      System.out.println("Usage: java saaps.saam.DataLook <Db class name> <yyyy.mm.dd> <hh:mm:ss> <duration> \n   duration in minutes");
      System.exit(0);
    }
    Vector dboVec=null;
    Object dbo=null;

//     StringTokenizer tokens = new StringTokenizer(args[0]);
//     if(tokens.countTokens()<3) {
//       System.out.println(tokens.countTokens());
//       System.out.println("Usage: java saaps.saam.DataLook <Db class name> <yyyy.mm.dd> <hh:mm:ss>");
//       System.exit(0);
//     }
    
    DataLook dl = new DataLook(args[0]); //First arg

    String dateTime = new String(args[1] + " " + args[2]);

    Calendar sd = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));
    Calendar ed = Calendar.getInstance(TimeZone.getTimeZone("UTC"),new Locale("sv","SE"));

    DateFormat mf = DateFormat.getDateTimeInstance();
    mf.setCalendar(sd); //Set our locale and UTC


    sd.set(2000,0,27,0,0,0); // 15:00 UTC 17:00 CEST
    sd.clear(sd.MILLISECOND);

    //    ed.set(2002,10,26,12,0,0); //Why is month - 1? 12:00 UTC 14:00 CEST

    SimpleDateFormat formatter = (SimpleDateFormat) SimpleDateFormat.getDateTimeInstance(0,0,new Locale("sv","SE"));

    formatter.setTimeZone(TimeZone.getTimeZone("UTC"));
    formatter.applyPattern("yyyy.MM.dd HH:mm:ss");
     
    // Parse the string back into a Date.
    ParsePosition pos = new ParsePosition(0);
    Date inputDateTime = formatter.parse(dateTime, pos);


    //System.out.println( inputDateTime );

    sd.setTime(inputDateTime);
    sd.clear(sd.MILLISECOND);


    ed.setTime(new Date ((long) sd.getTime().getTime() + (new Long(args[3])).longValue()*60*1000));
    ed.clear(ed.MILLISECOND);
    //System.out.println("endDate: " + ed.getTime());

    //Check what we got
    //    System.out.println(mf.format(sd.getTime()) + " " + sd.getTime() + mf.format(ed.getTime()) + " " + ed.getTime());

    if(dl.dbRef.isSet()) { // Check if metadata is set
      //System.out.println(" " + dl.dbRef.meta.getDescr());
      try {
        dboVec=dl.dbRef.retrieve(sd.getTime(),ed.getTime(),false);
	for(int i=0;i<dboVec.size();i++) {
	  System.out.println((dboVec.elementAt(i)).toString());
	}
	//	dbo = dl.dbRef.retrieve(sd.getTime());
	//System.out.println("ONE:" + dbo.toString());
      }
      catch (IOException e) {
	System.err.println(e);
	e.printStackTrace();
      }
    }
    try {
      dl.dbRef.close();
    }
    catch (IOException ee) {
	System.err.println(ee);
	ee.printStackTrace();
    }

  }	
}
