package saaps.dbt;

import java.applet.Applet; 
import java.awt.Graphics; 
import java.rmi.Naming; 
import java.rmi.RemoteException; 

import java.util.Vector;
import java.util.Date;
import java.util.Calendar;
import java.util.Locale;
import java.util.TimeZone;

import saaps.util.TimeSeries;
import Jama.*;
import ptolemy.plot.Plot;


public class DatabaseRMIApplet extends Applet { 

  protected Vector result = new Vector(0);

  protected Vector list = null;
  protected MetaData[] metaTest=null;

  protected TimeSeries ts = null;
  protected Matrix data = null;

  // "obj" is the identifier that we'll use to refer 
  // to the remote object that implements the "Hello" 
  // interface 
  DatabaseRMI obj = null; 

  public void init() { 

    try { 
      obj = (DatabaseRMI)Naming.lookup("//" + 
				       getCodeBase().getHost() + ":2001" + "/DatabaseRMIServer"); 

      // Get start/stop date/times for "overlapping data
      //dates=obj.getDate("Kp", "M3");

      //Get start/stop date/time for "single" data
      //  SPdates=obj.getSPDates("Kp");
      //  Anomdates=obj.getAnomDates("M3");

      //What data is available ?
      list = obj.getDatabaseList();

      //Some metadata
      metaTest = new MetaData[list.size()];

      for(int i=0;i<list.size();i++) {
	metaTest[i] = obj.getMetaData((String) list.elementAt(i));
      }

      //Data for Kp (last in list)
      Date sd = new Date();
      int index=1;
      sd.setTime(metaTest[list.size()-index].getEndDate().getTime() - 600000);
      ts = obj.getTimeSeries((String) list.elementAt(list.size()-index),sd,metaTest[list.size()-index].getEndDate());

      //What time interval do we want data for ?
      // 	    Date dateStart=new Date(95,1-1,1,0,0,0);
      // 	    Date dateEnd=new Date(95,3-1,1,0,0,0);

      // 	    long startTime=dateStart.getTime();
      // 	    long endTime=dateEnd.getTime();
      // 	    long startWindow=-1*10 * 24 * 3600 * 1000;
      // 	    long endWindow=10 * 24 * 3600 * 1000;

      // 	    myrowvec=obj.getSupData("Kp","M3",startTime,endTime, startWindow, endWindow);


      // Plot.
      // Create the plot surface.
      //	    Plot plot = new Plot();
      //plot.setSize(430,300);
      //plot.setButtons(true);


    } catch (Exception e) { 
      System.out.println("DatabaseRMIApplet exception: " + 
			 e.getMessage()); 
      e.printStackTrace(); 
    }

  }

  public void paint(Graphics g) { 
	
    int tmp=30;
    int beg=25;

    for(int i=0; i<list.size(); i++) {
      g.drawString(((String) list.elementAt(i)),35,tmp);
      tmp+=10;
    }

    for(int i=0; i<metaTest.length; i++) {
      System.out.println(metaTest[i].getDescr());
      //      g.drawString(((String) list.elementAt(i)),35,tmp);
      //      tmp+=10;      
    }
    Matrix data = ts.getData();
    data.print(4,1);

//     for(int i=0; i<data.size(); i++) {
//       g.drawString(Double.toString((double) ((DatabaseObject) data.elementAt(i)).getData(0)),35,tmp);
//       tmp+=10;
//     }
  } 
}
