package saaps.math;

public class ColVector
{
	int numOfRows;
	double[] element;

	public ColVector(int i)
	{
		numOfRows = i;
		element = new double[numOfRows];
	}

	public Matrix times(RowVector rv)
	{
		Matrix res = null;
		if(numOfRows == rv.getNumOfCols())
		{
			res = new Matrix(numOfRows,rv.getNumOfCols());
			for (int row=0;row<numOfRows;row++)
				for (int col=0;col<rv.getNumOfCols();col++)
					res.setElement(row,col, element[row] * rv.getElement(col));
		}
		else
		{
			System.err.println("Number of rows and columns must be equal!");
			System.exit(1);
		}
		return res;
	}
	
	public ColVector times(ColVector cv)
	{
		ColVector res = null;
		if(numOfRows == cv.getNumOfRows())
		{
			res = new ColVector(numOfRows);
			for (int row=0;row<numOfRows;row++)
				res.setElement(row, element[row] * cv.getElement(row));
		}
		else
		{
			System.err.println("Number of rows and columns must be equal!");
			System.exit(1);
		}
		return res;
	}

	public ColVector times(double v)
	{
		ColVector res = new ColVector(numOfRows);
		for (int i=0;i<numOfRows;i++)
			res.setElement(i, element[i] * v);
		return res;
	}		
	
	public RowVector transpose()
	{
		RowVector res = new RowVector(numOfRows);
		for (int i=0;i<numOfRows;i++)
			res.setElement(i,element[i]);
		return res;
	}
	
	public double getElement(int r)
	{
		return element[r];
	}
	
	public void setElement(int r, double v)
	{
		element[r] = v;
	}
	
	public int getNumOfRows()
	{
		return numOfRows;
	}
}