package saaps.math;

/**
* The class DoubleMatrix implements a vector of DoubleVector object.
* It has methods for performing matrix based arithmetics.
*
* @author Peter Wintoft
* @version 1.0 1999-09-21
*/
public class DoubleMatrix
{
	private DoubleVector[] vector;
	private int size;
	public DoubleMatrix(int capacity)
	{
		vector = new DoubleVector[capacity];
		size = capacity;
	}
	public void add(DoubleMatrix matrix)
	{
		for (int i=0;i<size;i++)
			vector[i].add(matrix.elementAt(i));
	}
	public DoubleVector elementAt(int i)
	{
		return vector[i];
	}
	public void divide(double d)
	{
		for (int i=0;i<size;i++)
			vector[i].divide(d);
	}
	public int size()
	{
		return size;
	}
}