/*
 * AnomalyPlotterData.java
 *
 * Created on August 21, 2001, 1:51 PM
 */

package saaps.saam;

import java.awt.FileDialog;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class AnomalyPlotterData extends java.awt.Dialog {
    
    //True if OK has been pushed.
    boolean isOK = false;
    
    //The parent frame.
    java.awt.Frame parentFrame;

    private AppHelp help = null;
    
    /** Creates new form AnomalyPlotterData */
    public AnomalyPlotterData(java.awt.Frame parent, boolean modal) {
        super (parent, modal);
        this.parentFrame = parent;
        initComponents ();
        pack ();
        // Java 6 fix for modal block of help window
        this.setModalityType(java.awt.Dialog.ModalityType.DOCUMENT_MODAL);
    }
    
    public AnomalyPlotterData(java.awt.Frame parent, String data) {
        this(parent, true);
        this.textArea.setText(data);
    }
    
    public boolean isOK() {
        return this.isOK;
    }
    
    public String getDataString() {
        return this.textArea.getText();
    }

    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        labelTitle = new java.awt.Label();
        textArea = new java.awt.TextArea();
        panelSouth = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonReadFromFile = new java.awt.Button();
        buttonOK = new java.awt.Button();
        buttonCancel = new java.awt.Button();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        labelTitle.setFont(new java.awt.Font("Dialog", 1, 18));
        labelTitle.setName("label8");
        labelTitle.setBackground(new java.awt.Color(204, 204, 204));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setText("Anomaly Data");
        labelTitle.setAlignment(java.awt.Label.CENTER);
        add(labelTitle, java.awt.BorderLayout.NORTH);
        
        textArea.setBackground(new java.awt.Color(255, 247, 233));
        textArea.setName("text2");
        textArea.setFont(new java.awt.Font("Dialog", 0, 11));
        textArea.setForeground(java.awt.Color.black);
        add(textArea, java.awt.BorderLayout.CENTER);
        
        panelSouth.setFont(new java.awt.Font("Dialog", 0, 11));
        panelSouth.setName("panel10");
        panelSouth.setBackground(new java.awt.Color(204, 204, 204));
        panelSouth.setForeground(java.awt.Color.black);
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button22");
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonHelp);
        
        buttonReadFromFile.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonReadFromFile.setLabel("Read from file ...");
        buttonReadFromFile.setName("button23");
        buttonReadFromFile.setBackground(new java.awt.Color(204, 204, 204));
        buttonReadFromFile.setForeground(java.awt.Color.black);
        buttonReadFromFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonReadFromFileActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonReadFromFile);
        
        buttonOK.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonOK.setLabel("OK");
        buttonOK.setName("button24");
        buttonOK.setBackground(new java.awt.Color(204, 204, 204));
        buttonOK.setForeground(java.awt.Color.black);
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonOK);
        
        buttonCancel.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonCancel.setLabel("Cancel");
        buttonCancel.setName("button25");
        buttonCancel.setBackground(new java.awt.Color(204, 204, 204));
        buttonCancel.setForeground(java.awt.Color.black);
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCancelActionPerformed(evt);
            }
        });
        
        panelSouth.add(buttonCancel);
        
        add(panelSouth, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
      if(help != null)
          help.dispose();
      this.isOK = false;
      this.dispose();
  }//GEN-LAST:event_buttonCancelActionPerformed

  private void buttonReadFromFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonReadFromFileActionPerformed
// Add your handling code here:
      //Select a file.
      FileDialog fd = new FileDialog(this.parentFrame,"Select a file",FileDialog.LOAD);
      fd.setVisible(true);
      if (fd.getFile() != null) {
          String fileName = fd.getDirectory() + fd.getFile();
          try {
              //Read the data.
              BufferedReader reader = new BufferedReader(new FileReader(fileName));
              String textLine;
              while ((textLine = reader.readLine()) != null) {
                  this.textArea.append(textLine + "\n");
              }
              reader.close();
          }
          catch (FileNotFoundException e) {
              System.err.println(e);
          }
          catch (IOException e) {
              System.err.println(e);
          }
      }
  }//GEN-LAST:event_buttonReadFromFileActionPerformed

  private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
// Add your handling code here:
      this.isOK = true;
      this.dispose();
  }//GEN-LAST:event_buttonOKActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new AnomalyPlotterData (new java.awt.Frame (), true).show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Label labelTitle;
    private java.awt.TextArea textArea;
    private java.awt.Panel panelSouth;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonReadFromFile;
    private java.awt.Button buttonOK;
    private java.awt.Button buttonCancel;
    // End of variables declaration//GEN-END:variables

}
