/*
 * BestPredModelApp.java
 *
 * Created on June 7, 2001, 4:03 PM
 */

package saaps.saam;

//import saaps.util.EventList;
import saaps.util.EventListDialog;
import saaps.util.EventRandomDialog;
import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class BestPredModelApp extends java.awt.Frame {

    //The event list.
//    private EventList eventList = new EventList();
    
    //The non-event list.
//    private EventList nonEventList = new EventList();
    
    //The model to estimate the best prediction model.
    private BestPredModel bestPredModel;
    
    private String linCorr = "Linear correlation";
    private String condProb = "Conditional probability";
    private AppHelp help = null;
    private boolean eldSet = false;
    private boolean erdSet = false;
    
    /** Creates new form BestPredModelApp */
    public BestPredModelApp() {
        this.initComponents ();
        this.initChoice();
        this.pack();
        this.bestPredModel = new BestPredModel();
    }
    
    private void initChoice() {
        this.choiceEstimateMethod.add(this.linCorr);
//        this.choiceEstimateMethod.add("Mutual information");
        this.choiceEstimateMethod.add(this.condProb);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelEvent = new java.awt.Panel();
        buttonEvents = new java.awt.Button();
        buttonNonEvents = new java.awt.Button();
        buttonRandomEvents = new java.awt.Button();
        choiceEstimateMethod = new java.awt.Choice();
        buttonSubmit = new java.awt.Button();
        panelQuit = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        listModels = new java.awt.List();
        textAreaModel = new java.awt.TextArea();
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        }
        );
        
        panelEvent.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        panelEvent.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelEvent.setName("panel19");
        panelEvent.setBackground(new java.awt.Color (195, 205, 219));
        panelEvent.setForeground(java.awt.Color.black);
        
        buttonEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonEvents.setLabel("Edit Events ...");
          buttonEvents.setName("button29");
          buttonEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonEvents.setForeground(java.awt.Color.black);
          buttonEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonEventsActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints1.ipady = 9;
          gridBagConstraints1.insets = new java.awt.Insets(15, 4, 0, 4);
          panelEvent.add(buttonEvents, gridBagConstraints1);
          
          
        buttonNonEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonNonEvents.setLabel("Edit Non-Events ...");
          buttonNonEvents.setName("button30");
          buttonNonEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonNonEvents.setForeground(java.awt.Color.black);
          buttonNonEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonNonEventsActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints1.ipady = 9;
          gridBagConstraints1.insets = new java.awt.Insets(15, 4, 0, 4);
          panelEvent.add(buttonNonEvents, gridBagConstraints1);
          
          
        buttonRandomEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonRandomEvents.setLabel("Random Non-Events ...");
          buttonRandomEvents.setName("button85");
          buttonRandomEvents.setBackground(new java.awt.Color (204, 204, 204));
          buttonRandomEvents.setForeground(java.awt.Color.black);
          buttonRandomEvents.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonRandomEventsActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints1.ipady = 9;
          gridBagConstraints1.insets = new java.awt.Insets(15, 4, 0, 4);
          panelEvent.add(buttonRandomEvents, gridBagConstraints1);
          
          
        choiceEstimateMethod.setFont(new java.awt.Font ("Dialog", 0, 11));
          choiceEstimateMethod.setBackground(new java.awt.Color (204, 204, 204));
          choiceEstimateMethod.setForeground(java.awt.Color.black);
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints1.ipady = 9;
          gridBagConstraints1.insets = new java.awt.Insets(15, 4, 0, 4);
          panelEvent.add(choiceEstimateMethod, gridBagConstraints1);
          
          
        buttonSubmit.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonSubmit.setLabel("Submit ...");
          buttonSubmit.setName("button35");
          buttonSubmit.setBackground(new java.awt.Color (167, 177, 199));
          buttonSubmit.setForeground(java.awt.Color.black);
          buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonSubmitActionPerformed(evt);
              }
          }
          );
          gridBagConstraints1 = new java.awt.GridBagConstraints();
          gridBagConstraints1.gridx = 0;
          gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints1.ipady = 9;
          gridBagConstraints1.insets = new java.awt.Insets(15, 4, 0, 4);
          panelEvent.add(buttonSubmit, gridBagConstraints1);
          
          
        add(panelEvent, java.awt.BorderLayout.WEST);
        
        
        panelQuit.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelQuit.setName("panel21");
        panelQuit.setBackground(new java.awt.Color (195, 205, 219));
        panelQuit.setForeground(java.awt.Color.black);
        
        buttonHelp.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonHelp.setLabel("Help");
          buttonHelp.setName("button33");
          buttonHelp.setBackground(new java.awt.Color (204, 204, 204));
          buttonHelp.setForeground(java.awt.Color.black);
          buttonHelp.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonHelpActionPerformed(evt);
              }
          }
          );
          panelQuit.add(buttonHelp);
          
          
        buttonQuit.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonQuit.setLabel("Quit");
          buttonQuit.setName("button34");
          buttonQuit.setBackground(new java.awt.Color (204, 204, 204));
          buttonQuit.setForeground(java.awt.Color.black);
          buttonQuit.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonQuitActionPerformed(evt);
              }
          }
          );
          panelQuit.add(buttonQuit);
          
          
        add(panelQuit, java.awt.BorderLayout.SOUTH);
        
        
        listModels.setFont(new java.awt.Font ("Dialog", 0, 11));
        listModels.setBackground(new java.awt.Color (255, 247, 233));
        listModels.setForeground(java.awt.Color.black);
        listModels.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listModelsItemStateChanged(evt);
            }
        }
        );
        
        add(listModels, java.awt.BorderLayout.EAST);
        
        
        textAreaModel.setBackground(new java.awt.Color (255, 247, 233));
        textAreaModel.setEditable(false);
        textAreaModel.setFont(new java.awt.Font ("Dialog", 0, 11));
        textAreaModel.setColumns(60);
        textAreaModel.setForeground(java.awt.Color.black);
        
        add(textAreaModel, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonRandomEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomEventsActionPerformed
// Add your handling code here:
      if (this.bestPredModel.getEventList() == null) {
          new ErrorDialog(this,"      Please edit the event list first!    ");
      }
      else {
          EventRandomDialog erd = new EventRandomDialog(this,this.bestPredModel.getEventList());
          erd.setVisible(true);
          if (erd.isOK() && (erd.getEventList()).getNumOfEvents()>0) {
              this.bestPredModel.setNonEventList(erd.getEventList());
              this.erdSet=true;
//              this.eldSet=true;
          }
      }
  }//GEN-LAST:event_buttonRandomEventsActionPerformed

  private void listModelsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listModelsItemStateChanged
// Add your handling code here:
      //Get the index of the selected item.
      int i = this.listModels.getSelectedIndex();
      //Display info about the selected item.
//      this.textAreaModel.setText(this.bestPredModel.getModelList().getModel(i).toString());
      this.textAreaModel.setText(this.bestPredModel.toString(i));
  }//GEN-LAST:event_listModelsItemStateChanged

  private void buttonSubmitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSubmitActionPerformed
      if(!(this.eldSet && this.erdSet)) {
          new ErrorDialog(this,"      Please edit the event lists first!    ");
      }
      else {
          this.textAreaModel.setText("Running models.\nThis may take some time.\nPlease wait ...");
          this.bestPredModel.update();
          this.bestPredModel.runModels();
          if (this.choiceEstimateMethod.getSelectedItem().equalsIgnoreCase(linCorr)) {
              this.bestPredModel.setStatistics(BestPredModel.LINCORR);
              this.textAreaModel.setText("LINCORR");
          }
          if (this.choiceEstimateMethod.getSelectedItem().equalsIgnoreCase(condProb)) {
              this.bestPredModel.setStatistics(BestPredModel.CONDPROB);
              this.textAreaModel.setText("CONDPROB");
          }
          this.bestPredModel.computeStatistics();
          this.bestPredModel.sortModels();
          this.listModels.clear();
          //System.out.println(this.bestPredModel.getNumOfModels());
          for (int i=0;i<this.bestPredModel.getNumOfModels();i++) {
              this.listModels.add(this.bestPredModel.getModelName(i));
              //System.out.println(this.bestPredModel.getModelName(i));
          }
          //Select the best model.
          this.listModels.select(0);
          this.textAreaModel.setText(this.bestPredModel.toString(0));
          //      this.listModels.repaint();
      }
  }//GEN-LAST:event_buttonSubmitActionPerformed

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonNonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonNonEventsActionPerformed
// Add your handling code here:
      EventListDialog erd = new EventListDialog(this,"Non-event list",this.bestPredModel.getNonEventList());
      erd.setVisible(true);
      if (erd.isOK() && (erd.getEventList()).getNumOfEvents()>0) {
          this.bestPredModel.setNonEventList(erd.getEventList());
          this.erdSet=true;
      }
  }//GEN-LAST:event_buttonNonEventsActionPerformed

  private void buttonEventsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonEventsActionPerformed
// Add your handling code here:
      EventListDialog eld = new EventListDialog(this,"Event list",this.bestPredModel.getEventList());
      eld.setVisible(true);
      if (eld.isOK() && (eld.getEventList()).getNumOfEvents()>0) {
          this.bestPredModel.setEventList(eld.getEventList());
          this.eldSet=true;
      }
  }//GEN-LAST:event_buttonEventsActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        this.dispose();
        //        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new BestPredModelApp ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelEvent;
    private java.awt.Button buttonEvents;
    private java.awt.Button buttonNonEvents;
    private java.awt.Button buttonRandomEvents;
    private java.awt.Choice choiceEstimateMethod;
    private java.awt.Button buttonSubmit;
    private java.awt.Panel panelQuit;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    private java.awt.List listModels;
    private java.awt.TextArea textAreaModel;
    // End of variables declaration//GEN-END:variables

}
