/*
 * DataPlotterApp.java
 *
 * Created on June 7, 2001, 9:51 AM
 */

package saaps.saam;

import java.awt.*;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;

import saaps.dbt.ODIDatabase;
import saaps.dbt.Database;
import saaps.dbt.DatabaseItems;
import saaps.dbt.ShowMetaDataFrame;
import saaps.util.InfoDialog;
import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.AppHelp;
/**
 *
 * @author  root
 * @version
 */
public class DataPlotterApp extends java.awt.Frame {
    //Preferred frame size.
    Dimension preferredSize = new Dimension(330,310);

    //A calendar object for date calculations.
    private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));

    //The time series object.
    private TimeSeries tso;

    //An object to the ODI database.
    private ODIDatabase odiDatabase;

    //Help
    private AppHelp help=null;

    /** Creates new form DataPlotterApp */
    public DataPlotterApp() {
        initComponents ();
        this.odiDatabase = new ODIDatabase();
        this.initListDatabaseItems();
        this.setPreferredSize(preferredSize);
        pack ();
    }

    private void initListDatabaseItems() {
        //Get the database items.
//        Vector items = DatabaseItems.list();
        Vector items = odiDatabase.listDataset();
        //Create the list.
        for (int i=0;i<items.size();i++) {
		this.listDatabase.add((String)((Vector)items.elementAt(i)).elementAt(1));
        }
    }

    private Date parseStartDate() {
        return this.parseDate(this.textFieldStartYear,
                                this.textFieldStartMonth,
                                this.textFieldStartDate);
    }

    private Date parseEndDate() {
        this.parseDate(this.textFieldEndYear,
                                this.textFieldEndMonth,
                                this.textFieldEndDate);
        //Add 23 hours and 59 minutes.
        this.cal.add(Calendar.HOUR_OF_DAY,23);
        this.cal.add(Calendar.MINUTE,59);
        return this.cal.getTime();
    }

    private Date parseDate(TextField year, TextField month, TextField date) {
        this.cal.clear();
        this.cal.set(Calendar.YEAR,Integer.parseInt(year.getText()));
        this.cal.set(Calendar.MONTH,Integer.parseInt(month.getText())-1);
        this.cal.set(Calendar.DATE,Integer.parseInt(date.getText()));
        return this.cal.getTime();
    }

    private void verifyInputFields() throws NumberFormatException {
	Integer.valueOf(this.textFieldStartYear.getText());
	Integer.valueOf(this.textFieldEndYear.getText());
	Integer.valueOf(this.textFieldStartMonth.getText());
	Integer.valueOf(this.textFieldEndMonth.getText());
	Integer.valueOf(this.textFieldStartDate.getText());
	Integer.valueOf(this.textFieldEndDate.getText());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelMain = new java.awt.Panel();
        panelDatabase = new java.awt.Panel();
        labelDatabase = new java.awt.Label();
        listDatabase = new java.awt.List();
        buttonInspect = new java.awt.Button();
        panelGetData = new java.awt.Panel();
        panelTime = new java.awt.Panel();
        labelStart = new java.awt.Label();
        labelEnd = new java.awt.Label();
        textFieldStartYear = new java.awt.TextField();
        textFieldEndYear = new java.awt.TextField();
        textFieldStartMonth = new java.awt.TextField();
        textFieldEndMonth = new java.awt.TextField();
        textFieldStartDate = new java.awt.TextField();
        textFieldEndDate = new java.awt.TextField();
        buttonGetData = new java.awt.Button();
        panelXAxis = new java.awt.Panel();
        labelXAxis = new java.awt.Label();
        listXAxis = new java.awt.List();
        panelYAxis = new java.awt.Panel();
        labelYAxis = new java.awt.Label();
        listYAxis = new java.awt.List();
        labelTitle = new java.awt.Label();
        panelQuit = new java.awt.Panel();
        buttonPlot = new java.awt.Button();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panelMain.setLayout(new java.awt.GridLayout(2, 2));
        
        panelMain.setBackground(new java.awt.Color(204, 204, 204));
        panelMain.setFont(new java.awt.Font("Dialog", 0, 11));
        panelMain.setForeground(java.awt.Color.black);
        panelMain.setName("panel7");
        panelDatabase.setLayout(new java.awt.BorderLayout());
        
        panelDatabase.setBackground(new java.awt.Color(204, 204, 204));
        panelDatabase.setFont(new java.awt.Font("Dialog", 0, 11));
        panelDatabase.setForeground(java.awt.Color.black);
        panelDatabase.setName("panel2");
        labelDatabase.setAlignment(java.awt.Label.CENTER);
        labelDatabase.setBackground(new java.awt.Color(204, 204, 204));
        labelDatabase.setFont(new java.awt.Font("Dialog", 0, 11));
        labelDatabase.setForeground(java.awt.Color.black);
        labelDatabase.setName("label1");
        labelDatabase.setText("Database items");
        panelDatabase.add(labelDatabase, java.awt.BorderLayout.SOUTH);
        
        listDatabase.setBackground(new java.awt.Color(255, 247, 233));
        listDatabase.setFont(new java.awt.Font("Dialog", 0, 11));
        listDatabase.setForeground(java.awt.Color.black);
        listDatabase.setName("list1");
        listDatabase.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listDatabaseItemStateChanged(evt);
            }
        });
        
        panelDatabase.add(listDatabase, java.awt.BorderLayout.CENTER);
        
        buttonInspect.setBackground(new java.awt.Color(204, 204, 204));
        buttonInspect.setFont(new java.awt.Font("Dialog", 0, 12));
        buttonInspect.setForeground(java.awt.Color.black);
        buttonInspect.setLabel("Show MetaData");
        buttonInspect.setName("button3");
        buttonInspect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonInspectActionPerformed(evt);
            }
        });
        
        panelDatabase.add(buttonInspect, java.awt.BorderLayout.SOUTH);
        
        panelMain.add(panelDatabase);
        
        panelGetData.setLayout(new java.awt.BorderLayout());
        
        panelGetData.setBackground(new java.awt.Color(204, 204, 204));
        panelGetData.setFont(new java.awt.Font("Dialog", 0, 11));
        panelGetData.setForeground(java.awt.Color.black);
        panelGetData.setName("panel3");
        panelTime.setLayout(new java.awt.GridLayout(4, 2));
        
        panelTime.setBackground(new java.awt.Color(204, 204, 204));
        panelTime.setFont(new java.awt.Font("Dialog", 0, 11));
        panelTime.setForeground(java.awt.Color.black);
        panelTime.setName("panel4");
        labelStart.setBackground(new java.awt.Color(204, 204, 204));
        labelStart.setFont(new java.awt.Font("Dialog", 0, 11));
        labelStart.setForeground(java.awt.Color.black);
        labelStart.setName("label2");
        labelStart.setText("Start");
        panelTime.add(labelStart);
        
        labelEnd.setBackground(new java.awt.Color(204, 204, 204));
        labelEnd.setFont(new java.awt.Font("Dialog", 0, 11));
        labelEnd.setForeground(java.awt.Color.black);
        labelEnd.setName("label3");
        labelEnd.setText("End (incl)");
        panelTime.add(labelEnd);
        
//        textFieldStartYear.setText("textField1");
        textFieldStartYear.setText("YYYY");
        textFieldStartYear.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartYear.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldStartYear.setForeground(java.awt.Color.black);
        panelTime.add(textFieldStartYear);
        
//        textFieldEndYear.setText("textField2");
        textFieldEndYear.setText("YYYY");
        textFieldEndYear.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndYear.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldEndYear.setForeground(java.awt.Color.black);
        panelTime.add(textFieldEndYear);
        
//        textFieldStartMonth.setText("textField3");
        textFieldStartMonth.setText("MM");
        textFieldStartMonth.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartMonth.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldStartMonth.setForeground(java.awt.Color.black);
        panelTime.add(textFieldStartMonth);
        
//        textFieldEndMonth.setText("textField4");
        textFieldEndMonth.setText("MM");
        textFieldEndMonth.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndMonth.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldEndMonth.setForeground(java.awt.Color.black);
        panelTime.add(textFieldEndMonth);
        
//        textFieldStartDate.setText("textField5");
        textFieldStartDate.setText("DD");
        textFieldStartDate.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartDate.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldStartDate.setForeground(java.awt.Color.black);
        panelTime.add(textFieldStartDate);
        
//        textFieldEndDate.setText("textField6");
        textFieldEndDate.setText("DD");
        textFieldEndDate.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndDate.setFont(new java.awt.Font("Dialog", 0, 12));
        textFieldEndDate.setForeground(java.awt.Color.black);
        textFieldEndDate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textField6ActionPerformed(evt);
            }
        });
        
        panelTime.add(textFieldEndDate);
        
        panelGetData.add(panelTime, java.awt.BorderLayout.CENTER);
        
        buttonGetData.setBackground(new java.awt.Color(204, 204, 204));
        buttonGetData.setFont(new java.awt.Font("Dialog", 0, 12));
        buttonGetData.setForeground(java.awt.Color.black);
        buttonGetData.setLabel("Get Data");
        buttonGetData.setName("button4");
        buttonGetData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonGetDataActionPerformed(evt);
            }
        });
        
        panelGetData.add(buttonGetData, java.awt.BorderLayout.SOUTH);
        
        panelMain.add(panelGetData);
        
        panelXAxis.setLayout(new java.awt.BorderLayout());
        
        panelXAxis.setBackground(new java.awt.Color(204, 204, 204));
        panelXAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        panelXAxis.setForeground(java.awt.Color.black);
        panelXAxis.setName("panel5");
        labelXAxis.setBackground(new java.awt.Color(204, 204, 204));
        labelXAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        labelXAxis.setForeground(java.awt.Color.black);
        labelXAxis.setName("label4");
        labelXAxis.setText("X Axis Data");
        panelXAxis.add(labelXAxis, java.awt.BorderLayout.NORTH);
        
        listXAxis.setBackground(new java.awt.Color(255, 247, 233));
        listXAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        listXAxis.setForeground(java.awt.Color.black);
        listXAxis.setName("list2");
        panelXAxis.add(listXAxis, java.awt.BorderLayout.CENTER);
        
        panelMain.add(panelXAxis);
        
        panelYAxis.setLayout(new java.awt.BorderLayout());
        
        panelYAxis.setBackground(new java.awt.Color(204, 204, 204));
        panelYAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        panelYAxis.setForeground(java.awt.Color.black);
        panelYAxis.setName("panel6");
        labelYAxis.setBackground(new java.awt.Color(204, 204, 204));
        labelYAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        labelYAxis.setForeground(java.awt.Color.black);
        labelYAxis.setName("label5");
        labelYAxis.setText("Y Axis Data");
        panelYAxis.add(labelYAxis, java.awt.BorderLayout.NORTH);
        
        listYAxis.setBackground(new java.awt.Color(255, 247, 233));
        listYAxis.setFont(new java.awt.Font("Dialog", 0, 11));
        listYAxis.setForeground(java.awt.Color.black);
        listYAxis.setMultipleMode(true);
        listYAxis.setName("list3");
        panelYAxis.add(listYAxis, java.awt.BorderLayout.CENTER);
        
        panelMain.add(panelYAxis);
        
        add(panelMain, java.awt.BorderLayout.CENTER);
        
        labelTitle.setAlignment(java.awt.Label.CENTER);
        labelTitle.setBackground(new java.awt.Color(204, 204, 204));
        labelTitle.setFont(new java.awt.Font("Dialog", 0, 18));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setName("label6");
        labelTitle.setText("Data Plotter");
        add(labelTitle, java.awt.BorderLayout.NORTH);
        
        panelQuit.setBackground(new java.awt.Color(204, 204, 204));
        panelQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        panelQuit.setForeground(java.awt.Color.black);
        panelQuit.setName("panel8");
        buttonPlot.setBackground(new java.awt.Color(204, 204, 204));
        buttonPlot.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonPlot.setForeground(java.awt.Color.black);
        buttonPlot.setLabel("Plot");
        buttonPlot.setName("button24");
        buttonPlot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonPlotActionPerformed(evt);
            }
        });
        
        panelQuit.add(buttonPlot);
        
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button5");
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelQuit.add(buttonHelp);
        
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button6");
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelQuit.add(buttonQuit);
        
        add(panelQuit, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void buttonPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonPlotActionPerformed
// Add your handling code here:
      //Get the indices of the selected fields.
      int xField = listXAxis.getSelectedIndex()-1;
      int[] yFields = listYAxis.getSelectedIndexes();
      //Set default plot options.
      boolean lines = true;
      boolean points = false;
      boolean xLog = false;
      boolean yLog = false;
//    String xLabel = listXAxis.getSelectedItem();
//    String[] yLabels = listYAxis.getSelectedItems();
      //Make sure that there are data to plot.
      if (tso != null) {
          new PlotFrame(tso,xField,yFields,lines,points,xLog,yLog).setVisible(true);
      }
      else {
          new InfoDialog(this,"Error!","There are no data to plot.",40).setVisible(true);
      }
//    pf.show();
  }//GEN-LAST:event_buttonPlotActionPerformed

  private void listDatabaseItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemStateChanged
// Add your handling code here:
      //Get the selected item.
      String item = this.listDatabase.getSelectedItem();
      //Get the end date for this item.
//      Database db = Database.getInstance(item,true);
//      Date endDate = db.meta.getEndDate();
      Date endDate = odiDatabase.getEndDate(item);
      //Create a calendar object.
      this.cal.setTime(endDate);
      //Put the end date into the end date text fields.
      DecimalFormat df = new DecimalFormat("##00");
      this.textFieldEndYear.setText(df.format(cal.get(Calendar.YEAR)));
      this.textFieldEndMonth.setText(df.format(cal.get(Calendar.MONTH)+1));
      this.textFieldEndDate.setText(df.format(cal.get(Calendar.DATE)));
      //Put the date into the start date text fields.
      this.textFieldStartYear.setText(df.format(cal.get(Calendar.YEAR)));
      this.textFieldStartMonth.setText(df.format(cal.get(Calendar.MONTH)+1));
      this.textFieldStartDate.setText(df.format(cal.get(Calendar.DATE)));
      /* clear the possible fields in the other lists */
      this.listXAxis.clear();
      this.listYAxis.clear();
  }//GEN-LAST:event_listDatabaseItemStateChanged

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
// Add your handling code here:
      if(help != null)
          help.dispose();
      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
  }//GEN-LAST:event_buttonHelpActionPerformed

	private void buttonGetDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGetDataActionPerformed
		try {
			//Get the selected item.
			String item = this.listDatabase.getSelectedItem();
			//Make sure that an item has been selected.
			if (item != null) {
				verifyInputFields();

				java.awt.Dialog dialog = new java.awt.Dialog(this, "Reading db ...", false);
				dialog.add(new java.awt.Label("Please wait ...                                        "));
				dialog.pack();
				dialog.setVisible(true);

				//Get the start date.
				Date sd = this.parseStartDate();
				//Get the end date.
				Date ed = this.parseEndDate();
				//Get the data.
				tso = odiDatabase.retrieveTS(item,sd,ed);
				//Get the field names.
				String[] fieldNames = tso.getFieldNames();
				String[] listNames = tso.getListNames();
				//Init the x-axis and y-axis lists.
				this.listXAxis.clear();
				this.listYAxis.clear();
				this.listXAxis.add("Time");
				for (int i=0;i<fieldNames.length-1;i++) {
					this.listXAxis.add(listNames[i]);
//					this.listXAxis.add(fieldNames[i]);
//					this.listYAxis.add(fieldNames[i]);
					this.listYAxis.add(listNames[i]);
				}
				dialog.dispose();
			}
			else {
				new InfoDialog(this,"Error!","A database item must first be selected.",40).setVisible(true);
			}
		}
		catch (NumberFormatException e) {
			new ErrorDialog(this,"Incorrect date format specified.");
		}
//		catch (IOException e) {
//			new InfoDialog(this,"Error!",e.getMessage(),40).setVisible(true);
//	  //              System.err.println(e);
//		}
	}//GEN-LAST:event_buttonGetDataActionPerformed

  private void buttonInspectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
// Add your handling code here:
      //Get the selected item.
      String item = this.listDatabase.getSelectedItem();

      if (item == null)
	    new InfoDialog(this,"Error!","A database item must first be selected.",40).setVisible(true);
      else
      //Show the meta data.
	    new ShowMetaDataFrame(item).setVisible(true);
  }//GEN-LAST:event_buttonInspectActionPerformed

  private void textField6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textField6ActionPerformed
// Add your handling code here:
  }//GEN-LAST:event_textField6ActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new DataPlotterApp ().show ();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelMain;
    private java.awt.Panel panelDatabase;
    private java.awt.Label labelDatabase;
    private java.awt.List listDatabase;
    private java.awt.Button buttonInspect;
    private java.awt.Panel panelGetData;
    private java.awt.Panel panelTime;
    private java.awt.Label labelStart;
    private java.awt.Label labelEnd;
    private java.awt.TextField textFieldStartYear;
    private java.awt.TextField textFieldEndYear;
    private java.awt.TextField textFieldStartMonth;
    private java.awt.TextField textFieldEndMonth;
    private java.awt.TextField textFieldStartDate;
    private java.awt.TextField textFieldEndDate;
    private java.awt.Button buttonGetData;
    private java.awt.Panel panelXAxis;
    private java.awt.Label labelXAxis;
    private java.awt.List listXAxis;
    private java.awt.Panel panelYAxis;
    private java.awt.Label labelYAxis;
    private java.awt.List listYAxis;
    private java.awt.Label labelTitle;
    private java.awt.Panel panelQuit;
    private java.awt.Button buttonPlot;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    // End of variables declaration//GEN-END:variables
}
