/*
 * SEAApp.java
 *
 * Created on June 19, 2001, 1:45 PM
 */

package saaps.saam;

import java.io.IOException;
import java.util.*;

import saaps.dbt.Database;
import saaps.dbt.ODIDatabase;
import saaps.dbt.MetaData;
import saaps.util.IllegalTimeSeriesException;
import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.TimeSeriesIndexException;
import saaps.util.AppHelp;

/**
 *
 * @author  leif
 * @version
 */
public class SEAApp extends java.awt.Panel {
    private ODIDatabase odiDatabase;

    private AppHelp help = null;
    
    /** Creates new form SEAApp */
    public SEAApp(java.awt.Frame aFrame) {
	this.odiDatabase = new ODIDatabase();
	parentFrame = aFrame;
	initComponents ();        
	setBackground(java.awt.Color.white);        
	init();
    }
    
      /** Initializes the Form */
    private void init () {
        choiceStart.add("days");
        choiceStart.add("hours");
        choiceStart.add("minutes");
        choiceEnd.add("days");
        choiceEnd.add("hours");
        choiceEnd.add("minutes");
        int width = 650;
        int height = 750;
        resize(width,height);
        cal.clear();
        initListDatabase();
    }
    
    private void initListDatabase() {
        Vector list = null;
        try
        {
//            list = saaps.dbt.DatabaseItems.list();
            list = odiDatabase.listDataset();
        }
        catch (Exception e)
        {
            System.err.println(e);
        }
        for (int i=0;i<list.size();i++)
            listDatabase.add((String)((Vector)list.elementAt(i)).elementAt(1));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        label1 = new java.awt.Label();
        buttonHelp = new java.awt.Button();
        label3 = new java.awt.Label();
        textFieldEventList = new java.awt.TextField();
        label4 = new java.awt.Label();
        textAreaEventList = new java.awt.TextArea();
        startEndPanel = new java.awt.Panel();
        label5 = new java.awt.Label();
        textFieldStart = new java.awt.TextField();
        choiceStart = new java.awt.Choice();
        label6 = new java.awt.Label();
        textFieldEnd = new java.awt.TextField();
        choiceEnd = new java.awt.Choice();
        selPanel = new java.awt.Panel();
        label7 = new java.awt.Label();
        label8 = new java.awt.Label();
        listDatabase = new java.awt.List();
        listField = new java.awt.List();
        buttonInspect = new java.awt.Button();
        buttonCalculate = new java.awt.Button();
        panelRight = new java.awt.Panel();
        label2 = new java.awt.Label();
        textFieldRandomList = new java.awt.TextField();
        textAreaRandomList = new java.awt.TextArea();
        label9 = new java.awt.Label();
        textFieldNumOfRandom = new java.awt.TextField();
        buttonGenerateRandomList = new java.awt.Button();
        buttonRandomPlot = new java.awt.Button();
        button3 = new java.awt.Button();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        label1.setFont(new java.awt.Font ("Dialog", 1, 14));
        label1.setText("Superposed Epoch Analysis");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(label1, gridBagConstraints1);
        
        
        buttonHelp.setFont(new java.awt.Font ("Dialog", 1, 14));
        buttonHelp.setLabel("Help");
        buttonHelp.setName("buttonHelp");
        buttonHelp.setBackground(new java.awt.Color (204, 204, 204));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        add(buttonHelp, gridBagConstraints1);
        
        
        label3.setText("Event List");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(label3, gridBagConstraints1);
        
        
        textFieldEventList.setEditable(false);
        textFieldEventList.setFont(new java.awt.Font ("Monospaced", 0, 12));
        textFieldEventList.setForeground(java.awt.Color.black);
        textFieldEventList.setText("YYYY MM DD hh mm ss");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(textFieldEventList, gridBagConstraints1);
        
        
        label4.setText("Event Window");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(label4, gridBagConstraints1);
        
        
        textAreaEventList.setBackground(new java.awt.Color (255, 247, 233));
        textAreaEventList.setFont(new java.awt.Font ("Monospaced", 0, 12));
        textAreaEventList.setColumns(16);
        textAreaEventList.setForeground(java.awt.Color.black);
        textAreaEventList.setText("2006 07 14 10 45\n2006 11 08 23 35");
        textAreaEventList.setRows(8);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(textAreaEventList, gridBagConstraints1);
        
        
        startEndPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        startEndPanel.setFont(new java.awt.Font ("Dialog", 0, 11));
        startEndPanel.setName("panel25");
        startEndPanel.setBackground(getBackground());
        startEndPanel.setForeground(java.awt.Color.black);
        
        label5.setText("Start");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          startEndPanel.add(label5, gridBagConstraints2);
          
          
        textFieldStart.setBackground(new java.awt.Color (255, 247, 233));
          textFieldStart.setName("textfieldStart");
          textFieldStart.setForeground(java.awt.Color.black);
          textFieldStart.setText("-2");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          startEndPanel.add(textFieldStart, gridBagConstraints2);
          
          
        gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
          startEndPanel.add(choiceStart, gridBagConstraints2);
          
          
        label6.setText("End");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          startEndPanel.add(label6, gridBagConstraints2);
          
          
        textFieldEnd.setBackground(new java.awt.Color (255, 247, 233));
          textFieldEnd.setForeground(java.awt.Color.black);
          textFieldEnd.setText("2");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          startEndPanel.add(textFieldEnd, gridBagConstraints2);
          
          
        gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridy = 3;
          startEndPanel.add(choiceEnd, gridBagConstraints2);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.ipadx = 40;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        add(startEndPanel, gridBagConstraints1);
        
        
        selPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        selPanel.setFont(new java.awt.Font ("Dialog", 0, 11));
        selPanel.setName("panel26");
        selPanel.setBackground(getBackground());
        selPanel.setForeground(java.awt.Color.black);
        
        label7.setText("Database");
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          gridBagConstraints3.insets = new java.awt.Insets(0, 0, 0, 10);
          selPanel.add(label7, gridBagConstraints3);
          
          
        label8.setText("Field");
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          selPanel.add(label8, gridBagConstraints3);
          
          
        listDatabase.setBackground(new java.awt.Color (255, 247, 233));
          listDatabase.setForeground(java.awt.Color.black);
          listDatabase.addItemListener(new java.awt.event.ItemListener() {
              public void itemStateChanged(java.awt.event.ItemEvent evt) {
                  listDatabaseItemStateChanged(evt);
              }
          }
          );
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          gridBagConstraints3.gridx = 0;
          gridBagConstraints3.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints3.insets = new java.awt.Insets(0, 0, 0, 10);
          gridBagConstraints3.weighty = 1.0;
          selPanel.add(listDatabase, gridBagConstraints3);
          
          
        listField.setBackground(new java.awt.Color (255, 247, 233));
          listField.setForeground(java.awt.Color.black);
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          gridBagConstraints3.gridx = 1;
          gridBagConstraints3.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints3.weighty = 1.0;
          selPanel.add(listField, gridBagConstraints3);
          
          
        buttonInspect.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonInspect.setLabel("Inspect");
          buttonInspect.setName("button9");
          buttonInspect.setBackground(new java.awt.Color (204, 204, 204));
          buttonInspect.setForeground(java.awt.Color.black);
          buttonInspect.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonInspectActionPerformed(evt);
              }
          }
          );
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          gridBagConstraints3.gridx = 0;
          gridBagConstraints3.insets = new java.awt.Insets(14, 0, 0, 10);
          selPanel.add(buttonInspect, gridBagConstraints3);
          
          
        buttonCalculate.setLabel("Plot Events");
          buttonCalculate.setBackground(new java.awt.Color (204, 204, 204));
          buttonCalculate.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonCalculateActionPerformed(evt);
              }
          }
          );
          gridBagConstraints3 = new java.awt.GridBagConstraints();
          gridBagConstraints3.gridx = 1;
          gridBagConstraints3.insets = new java.awt.Insets(14, 0, 0, 0);
          selPanel.add(buttonCalculate, gridBagConstraints3);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 0);
        add(selPanel, gridBagConstraints1);
        
        
        panelRight.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        panelRight.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelRight.setName("panel4");
        panelRight.setBackground(java.awt.Color.orange);
        panelRight.setForeground(java.awt.Color.black);
        
        label2.setText("Random List");
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.insets = new java.awt.Insets(0, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(label2, gridBagConstraints4);
          
          
        textFieldRandomList.setBackground(new java.awt.Color (223, 223, 223));
          textFieldRandomList.setEditable(false);
          textFieldRandomList.setFont(new java.awt.Font ("Monospaced", 0, 12));
          textFieldRandomList.setForeground(java.awt.Color.black);
          textFieldRandomList.setText("YYYY MM DD hh mm ss");
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.insets = new java.awt.Insets(0, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(textFieldRandomList, gridBagConstraints4);
          
          
        textAreaRandomList.setBackground(new java.awt.Color (255, 247, 233));
          textAreaRandomList.setFont(new java.awt.Font ("Monospaced", 0, 12));
          textAreaRandomList.setColumns(19);
          textAreaRandomList.setForeground(java.awt.Color.black);
          textAreaRandomList.setRows(8);
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints4.insets = new java.awt.Insets(20, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          gridBagConstraints4.weighty = 1.0;
          panelRight.add(textAreaRandomList, gridBagConstraints4);
          
          
        label9.setFont(new java.awt.Font ("Dialog", 0, 11));
          label9.setForeground(java.awt.Color.black);
          label9.setText("Number of random events");
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.insets = new java.awt.Insets(20, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(label9, gridBagConstraints4);
          
          
        textFieldNumOfRandom.setBackground(new java.awt.Color (255, 247, 233));
          textFieldNumOfRandom.setFont(new java.awt.Font ("Dialog", 0, 11));
          textFieldNumOfRandom.setColumns(4);
          textFieldNumOfRandom.setForeground(java.awt.Color.black);
          textFieldNumOfRandom.setText("5");
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.insets = new java.awt.Insets(20, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(textFieldNumOfRandom, gridBagConstraints4);
          
          
        buttonGenerateRandomList.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonGenerateRandomList.setLabel("Generate random list");
          buttonGenerateRandomList.setBackground(new java.awt.Color (204, 204, 204));
          buttonGenerateRandomList.setForeground(java.awt.Color.black);
          buttonGenerateRandomList.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonGenerateRandomListActionPerformed(evt);
              }
          }
          );
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.insets = new java.awt.Insets(20, 10, 0, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(buttonGenerateRandomList, gridBagConstraints4);
          
          
        buttonRandomPlot.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonRandomPlot.setLabel("Plot Random Events");
          buttonRandomPlot.setBackground(new java.awt.Color (204, 204, 204));
          buttonRandomPlot.setForeground(java.awt.Color.black);
          buttonRandomPlot.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonRandomPlotActionPerformed(evt);
              }
          }
          );
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 0;
          gridBagConstraints4.insets = new java.awt.Insets(20, 10, 10, 0);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
          panelRight.add(buttonRandomPlot, gridBagConstraints4);
          
          
        button3.setFont(new java.awt.Font ("Dialog", 0, 11));
          button3.setLabel("Quit");
          button3.setName("button9");
          button3.setBackground(new java.awt.Color (204, 204, 204));
          button3.setForeground(java.awt.Color.black);
          button3.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  button3ActionPerformed(evt);
              }
          }
          );
          gridBagConstraints4 = new java.awt.GridBagConstraints();
          gridBagConstraints4.gridx = 1;
          gridBagConstraints4.gridy = 6;
          gridBagConstraints4.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints4.insets = new java.awt.Insets(0, 0, 10, 10);
          gridBagConstraints4.anchor = java.awt.GridBagConstraints.EAST;
          panelRight.add(button3, gridBagConstraints4);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridheight = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 0.5;
        gridBagConstraints1.weighty = 0.5;
        add(panelRight, gridBagConstraints1);
        
    }//GEN-END:initComponents
    
  private void listDatabaseItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemStateChanged
//      Database db = null;
      saaps.util.TimeSeries ts = null;
      try {
          String dbo = listDatabase.getSelectedItem();
//          MetaData md = db.meta;
          // Get the field names.
          String[] fn = odiDatabase.getListNames(dbo);
          // Clear the field list
          listField.removeAll();
          // Add the items
          for (int i=0;i<fn.length;i++)
              listField.add(fn[i]);
      }
      catch (Exception e) {
          System.err.println(e);
      }
/*      finally {
          try {
              if(db != null)
                  db.close();
          } catch (Exception me) {}
      }*/
  }//GEN-LAST:event_listDatabaseItemStateChanged
  
  private void buttonRandomPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomPlotActionPerformed
      try {
          
          Date[] events = parseList(textAreaRandomList);
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          // Read the database list.
          String dbo = parseDatabaseList();
          // Read the field list.
          int field = parseFieldList();
          
	  if (field == -1) {
	    new ErrorDialog(parentFrame,"Database and Field must be selected.");
	  }
          else if (events == null) {
	    new ErrorDialog(parentFrame,"Random List must be generated first.");
	  }
	  else {
            //Create dialog window.
            java.awt.Dialog dialog = new java.awt.Dialog(parentFrame, "Analysing ...", false);
            dialog.add(new java.awt.Label("Please wait ...                                        "));
            dialog.pack();
            dialog.setVisible(true);
//            SEADataDialog seaDD = new SEADataDialog(parentFrame,false);
//            seaDD.setVisible(true);
            //Get the data.
            SEADataLocal sea = null;
            sea = new SEADataLocal(events,startWindow,endWindow,dbo,field);
          
            //Remove the dialog window.
            dialog.dispose();
//            seaDD.dispose();
            //Plot the data.
            if (sea != null) {
              PlotFrame seaPlot = new PlotFrame(sea.getTimeSeries());
              seaPlot.useRelTime();
              seaPlot.plotData();
              seaPlot.show();
            }
          }
      }
      catch (NumberFormatException nfe) {
          System.err.println(nfe);
          new ErrorDialog(parentFrame,"Incorrect date format in list.");
      }      
      catch (TimeSeriesIndexException tsie) {
          new ErrorDialog(parentFrame,tsie.getMessage());
          System.err.println(tsie);
      }
      catch (IllegalTimeSeriesException itse) {
          new ErrorDialog(parentFrame,itse.getMessage());
          System.err.println(itse);
      }
      catch (IOException ioe) {
          new ErrorDialog(parentFrame,ioe.getMessage());
          System.err.println(ioe);
      }
  }//GEN-LAST:event_buttonRandomPlotActionPerformed
  
  private void buttonGenerateRandomListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGenerateRandomListActionPerformed
      try {
          int numOfRandom = 1;
          numOfRandom = Integer.parseInt(textFieldNumOfRandom.getText());
          // Read the event list.
          Date[] events = parseEventList();
          //Find the first and last events.
          long firstEvent = events[0].getTime();
          long lastEvent = firstEvent;
          for (int i=0;i<events.length;i++) {
              if (events[i].getTime() < firstEvent)
                  firstEvent = events[i].getTime();
              if (events[i].getTime() > lastEvent)
                  lastEvent = events[i].getTime();
          }
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          firstEvent -= startWindow;
          lastEvent += endWindow;
          //Generate the random times.
          //    Date[] randomList = new Date[numOfRandom];
          Random rand = new Random();
          textAreaRandomList.setText("");
          for (int i=0;i<numOfRandom;i++) {
              StringBuffer strBuf = new StringBuffer();
              long randTime = (long) (rand.nextDouble() * (lastEvent-firstEvent) + firstEvent);
              Date randomDate = new Date(randTime);
              Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
              cal.setTime(randomDate);
              cal.clear(Calendar.MILLISECOND);
              strBuf.append(cal.get(Calendar.YEAR));
              int tmp = cal.get(Calendar.MONTH) + 1;
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.DATE);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.HOUR_OF_DAY);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.MINUTE);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.SECOND);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              strBuf.append("\n");
              textAreaRandomList.append(strBuf.toString());
          }
      }
      catch (NumberFormatException nfe) {
          System.err.println(nfe);
          new ErrorDialog(parentFrame,"Incorrect date format in list.");
      }
  }//GEN-LAST:event_buttonGenerateRandomListActionPerformed
  
  private void buttonCalculateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCalculateActionPerformed
      try {
          
          Date[] events = parseList(textAreaEventList);
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          // Read the database list.
          String dbo = parseDatabaseList();
          // Read the field list.
          int field = parseFieldList();
          if (field == -1) {
            new ErrorDialog(parentFrame,"Database and Field must be selected.");
          }
          else {
            //Check that there are data in the event list.
            //Check that a database object have been selected.
            //Check that a field has been selected.
            //Check that there are start and end times.
            java.awt.Dialog dialog = new java.awt.Dialog(parentFrame, "Analysing ...", false);
            dialog.add(new java.awt.Label("Please wait ...                                        "));
            dialog.pack();
            dialog.setVisible(true);
//            SEADataDialog seaDD = new SEADataDialog(parentFrame,false);
//            seaDD.setVisible(true);
          
            SEADataLocal sea = null;
            sea = new SEADataLocal(events,startWindow,endWindow,dbo,field);
          
            //    dialog.dispose();
            dialog.dispose();
//            seaDD.dispose();
            // Create plot if data was loaded.
            if (sea != null) {
              //Get the SEA TimeSeries.
              TimeSeries seaTS = sea.getTimeSeries();
              System.out.println("Length = " + seaTS.getLength());
              System.out.println("Num of data fields = " + seaTS.getNumOfDataFields());
              PlotFrame seaPlot = new PlotFrame(seaTS);
              seaPlot.useRelTime();
              seaPlot.plotData();
              seaPlot.show();
            }
         }
      }
      catch (NumberFormatException e) {
          new ErrorDialog(parentFrame,"Incorrect date format in list.");
      }
      catch (TimeSeriesIndexException tsie) {
          new ErrorDialog(parentFrame,tsie.getMessage());
          System.err.println(tsie);
      }
      catch (IllegalTimeSeriesException itse) {
          new ErrorDialog(parentFrame,itse.getMessage());
          System.err.println(itse);
      }
      catch (IOException ioe) {
          new ErrorDialog(parentFrame,ioe.getMessage());
          System.err.println(ioe);
      }
      
  }//GEN-LAST:event_buttonCalculateActionPerformed
  
  private void buttonInspectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
      String dbObject = (String) listDatabase.getSelectedItem();
      if (dbObject == null) {
	    new ErrorDialog(parentFrame,"Database must be selected.");
      }
      else {

        try {
            odiDatabase.getFieldNames(dbObject);
//          metaData = db.meta;
//          db.close();
            (new MetaDataDialog(parentFrame,dbObject)).show();
        }
        catch (Exception e) {
            System.err.println(e);
        }
      }
  }//GEN-LAST:event_buttonInspectActionPerformed
  
  private void button3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button3ActionPerformed
      if(help != null)
          help.dispose();
      parentFrame.dispose();
      //System.exit(0);
  }//GEN-LAST:event_button3ActionPerformed
  
  private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
  }//GEN-LAST:event_buttonHelpActionPerformed
  
  public static void main(java.lang.String[] args) {
      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
                    /** Exit the Application */
              myFrame.dispose();
              System.exit (0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color (204, 204, 204));
      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      
      myFrame.setName("SEA");
      myFrame.setTitle("Superposed Epoch Analysis");
      
      myFrame.add(new SEAApp(myFrame),gridBagConstraints1);
      myFrame.pack();
      myFrame.show();
  }
  
  public static void getSEAFrame() {
      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
                    /** Exit the Application */
              myFrame.dispose();
              System.exit (0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color (204, 204, 204));
      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      
      myFrame.setName("SEA");
      myFrame.setTitle("Superposed Epoch Analysis");
      
      myFrame.add(new SEAApp(myFrame),gridBagConstraints1);
      myFrame.pack();
      myFrame.show();
  }
  
  private Date[] parseList(java.awt.TextArea ta) {
      Date[] res = null;
      int[] dateFields = {Calendar.YEAR, Calendar.MONTH, Calendar.DATE,
      Calendar.HOUR_OF_DAY, Calendar.MINUTE, Calendar.SECOND};
      //    int numOfRows = textAreaEventList.getRows();
      String allText = ta.getText();
      // Tokenize with respect to newline.
      StringTokenizer stLine = new StringTokenizer(allText,"\n");
      int numOfLines = stLine.countTokens();
      if (numOfLines > 0)
          res = new Date[numOfLines];
      //    int numOfFields = numOfTokens/numOfRows;
      int row = 0;
      for (int i=0;i<numOfLines;i++) {
          // Tokenize one line.
          StringTokenizer stOneLine = new StringTokenizer(stLine.nextToken());
          //      String token = st.nextToken();
          int field = 0;
          while (stOneLine.hasMoreTokens()) {
              String token = stOneLine.nextToken();
              int t = Integer.parseInt(token);
              // The month number is the month minus 1.
              if (field==1)
                  t--;
              cal.set(dateFields[field],t);
              field++;
          }
          res[row] = cal.getTime();
          row++;
      }
      return res;
  }
  
  private Date[] parseEventList() {
      int[] dateFields = {Calendar.YEAR, Calendar.MONTH, Calendar.DATE,
      Calendar.HOUR_OF_DAY, Calendar.MINUTE, Calendar.SECOND};
      //    int numOfRows = textAreaEventList.getRows();
      String allText = textAreaEventList.getText();
      // Tokenize with respect to newline.
      StringTokenizer stLine = new StringTokenizer(allText,"\n");
      int numOfLines = stLine.countTokens();
      Date[] res = new Date[numOfLines];
      //    int numOfFields = numOfTokens/numOfRows;
      int row = 0;
      for (int i=0;i<numOfLines;i++) {
          // Tokenize one line.
          StringTokenizer stOneLine = new StringTokenizer(stLine.nextToken());
          //      String token = st.nextToken();
          int field = 0;
          while (stOneLine.hasMoreTokens())
          {
              String token = stOneLine.nextToken();
              int t = Integer.parseInt(token);
              // The month number is the month minus 1.
              if (field==1)
                  t--;
              cal.set(dateFields[field],t);
              field++;
          }
          res[row] = cal.getTime();
          row++;
      }
      return res;
  }
  
  private long parseEventWindowStart() {
      long res;
      String s = textFieldStart.getText();
      int i = choiceStart.getSelectedIndex();
      res = parseEventWindow(s,i);
      return res;
  }
  
  private long parseEventWindowEnd() {
      long res;
      String s = textFieldEnd.getText();
      int i = choiceEnd.getSelectedIndex();
      res = parseEventWindow(s,i);
      return res;
  }
  
  private long parseEventWindow(String s, int i)  {
      long res = -1;
      res = Long.parseLong(s);
      switch (i) {
          case 0:
              res = res*24*60*60*1000;
              break;
          case 1:
              res = res*60*60*1000;
              break;
          case 2:
              res = res*60*1000;
      }
      return res;
  }
  
  private String parseDatabaseList() {
      String res;
      res = listDatabase.getSelectedItem();
      return res;
  }
  
  private int parseFieldList() {
      int res;
      res = listField.getSelectedIndex();
      return res;
  }
  
  //MY variables
  private java.awt.Frame parentFrame;
  private MetaData metaData;
  private TimeZone tz = TimeZone.getTimeZone("GMT");
  private Calendar cal = Calendar.getInstance(tz);
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label label1;
  private java.awt.Button buttonHelp;
  private java.awt.Label label3;
  private java.awt.TextField textFieldEventList;
  private java.awt.Label label4;
  private java.awt.TextArea textAreaEventList;
  private java.awt.Panel startEndPanel;
  private java.awt.Label label5;
  private java.awt.TextField textFieldStart;
  private java.awt.Choice choiceStart;
  private java.awt.Label label6;
  private java.awt.TextField textFieldEnd;
  private java.awt.Choice choiceEnd;
  private java.awt.Panel selPanel;
  private java.awt.Label label7;
  private java.awt.Label label8;
  private java.awt.List listDatabase;
  private java.awt.List listField;
  private java.awt.Button buttonInspect;
  private java.awt.Button buttonCalculate;
  private java.awt.Panel panelRight;
  private java.awt.Label label2;
  private java.awt.TextField textFieldRandomList;
  private java.awt.TextArea textAreaRandomList;
  private java.awt.Label label9;
  private java.awt.TextField textFieldNumOfRandom;
  private java.awt.Button buttonGenerateRandomList;
  private java.awt.Button buttonRandomPlot;
  private java.awt.Button button3;
  // End of variables declaration//GEN-END:variables
    
}
