package saaps.saam;

import java.rmi.*;
import java.util.Date;

import saaps.dbt.*;
import saaps.math.*;
import saaps.util.*;

/**
*
* @author
* @version
*/
public class SEADataOld extends Object{
  //The uploaded time series.
  private TimeSeries sea;
  //The database connection.
  private DatabaseRMI dbRMI;

  public SEADataOld(Date[] eventDates, long sw, long ew, DatabaseRMI dbr, String dbo, int field)
  {
    dbRMI = dbr;
    // Go through each event and load data.
    // Get first event.
    long eventTime = eventDates[0].getTime();
    Date start = new Date(eventTime + sw);
    Date end = new Date(eventTime + ew);
    TimeSeries epoch = getTimeSeries(dbo,start,end);
    Jama.Matrix epochData = epoch.getData();
    Jama.Matrix oneField = epochData.getMatrix(0,epochData.getRowDimension()-1,field,field);
    Jama.Matrix data = new Jama.Matrix(epoch.getLength(),eventDates.length,Double.NaN);
    data.setMatrix(0,epoch.getLength()-1,0,0,oneField);
    // Get the rest of the events.
    for (int i=1;i<eventDates.length;i++)
    {
      eventTime = eventDates[i].getTime();
      start = new Date(eventTime + sw);
      end = new Date(eventTime + ew);
      epoch = getTimeSeries(dbo,start,end);
      epochData = epoch.getData();
      oneField = epochData.getMatrix(0,epochData.getRowDimension()-1,field,field);
      data.setMatrix(0,epoch.getLength()-1,i,i,oneField);
    }
    // Create the SEA time series.
    Date[] seaDates = new Date[epoch.getLength()];
    for (int i=0;i<seaDates.length;i++)
      seaDates[i] = new Date((ew-sw)/seaDates.length*i + sw);
    sea = new TimeSeries(seaDates,data);
  }

  private TimeSeries getTimeSeries(String dbo, Date sd, Date ed)
  {
    TimeSeries res = null;
    try
    {
      res = dbRMI.getTimeSeries(dbo,sd,ed);
    }
    catch(RemoteException re)
    {
      System.err.println(re);
      return null;
    }
    System.out.println("Read " + res.getLength() + " data points ...");
    return res;
  }

  public TimeSeries getTimeSeries()
  {
    return sea;
  }

}
