/*
 * EventListDialog.java
 *
 * Created on June 8, 2001, 12:15 PM
 */

package saaps.util;

import java.awt.FileDialog;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author  root
 * @version 
 */
public class EventListDialog extends java.awt.Dialog {

    //The parent frame.
    private java.awt.Frame parentFrame;
    
    //ok is true if the edited list should be used.
    private boolean ok = false;
    
    /** Creates new form EventListDialog */
    public EventListDialog(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        pack ();
    }

    public EventListDialog(java.awt.Frame parent,String title, EventList el) {
        super(parent,true);
        this.parentFrame = parent;
        this.initComponents();
        this.labelTitle.setText(title);
        if (el != null) {
            this.textAreaEvents.setText(el.toString());
        }
        this.pack();
    }
 
    public EventListDialog(java.awt.Dialog owner,String title, EventList el) {
        super(owner);
        this.initComponents();
        this.labelTitle.setText(title);
        if (el != null) {
            this.textAreaEvents.setText(el.toString());
        }
        this.pack();
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        labelTitle = new java.awt.Label();
        panelEvents = new java.awt.Panel();
        textAreaEvents = new java.awt.TextArea();
        labelEvents = new java.awt.Label();
        panelOK = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonReadFromFile = new java.awt.Button();
        buttonOK = new java.awt.Button();
        buttonCancel = new java.awt.Button();
        setLayout(new java.awt.BorderLayout());
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        labelTitle.setFont(new java.awt.Font ("Dialog", 1, 18));
        labelTitle.setName("label2");
        labelTitle.setBackground(new java.awt.Color (204, 204, 204));
        labelTitle.setForeground(java.awt.Color.black);
        labelTitle.setText("label1");
        
        add(labelTitle, java.awt.BorderLayout.NORTH);
        
        
        panelEvents.setLayout(new java.awt.BorderLayout());
        panelEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelEvents.setName("panel6");
        panelEvents.setBackground(new java.awt.Color (204, 204, 204));
        panelEvents.setForeground(java.awt.Color.black);
        
        textAreaEvents.setBackground(new java.awt.Color (255, 247, 233));
          textAreaEvents.setFont(new java.awt.Font ("Courier", 0, 11));
          textAreaEvents.setForeground(java.awt.Color.black);
          panelEvents.add(textAreaEvents, java.awt.BorderLayout.CENTER);
          
          
        labelEvents.setFont(new java.awt.Font ("Dialog", 0, 11));
          labelEvents.setName("label7");
          labelEvents.setBackground(new java.awt.Color (204, 204, 204));
          labelEvents.setForeground(java.awt.Color.black);
          labelEvents.setText("Year Month Day Hour Minute Second");
          panelEvents.add(labelEvents, java.awt.BorderLayout.NORTH);
          
          
        add(panelEvents, java.awt.BorderLayout.CENTER);
        
        
        panelOK.setFont(new java.awt.Font ("Dialog", 0, 11));
        panelOK.setName("panel7");
        panelOK.setBackground(new java.awt.Color (204, 204, 204));
        panelOK.setForeground(java.awt.Color.black);
        
        buttonHelp.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonHelp.setLabel("Help");
          buttonHelp.setName("button7");
          buttonHelp.setBackground(new java.awt.Color (204, 204, 204));
          buttonHelp.setForeground(java.awt.Color.black);
          panelOK.add(buttonHelp);
          
          
        buttonReadFromFile.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonReadFromFile.setLabel("Read from file ...");
          buttonReadFromFile.setName("button8");
          buttonReadFromFile.setBackground(new java.awt.Color (204, 204, 204));
          buttonReadFromFile.setForeground(java.awt.Color.black);
          buttonReadFromFile.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonReadFromFileActionPerformed(evt);
              }
          }
          );
          panelOK.add(buttonReadFromFile);
          
          
        buttonOK.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonOK.setLabel("OK");
          buttonOK.setName("button9");
          buttonOK.setBackground(new java.awt.Color (204, 204, 204));
          buttonOK.setForeground(java.awt.Color.black);
          buttonOK.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonOKActionPerformed(evt);
              }
          }
          );
          panelOK.add(buttonOK);
          
          
        buttonCancel.setFont(new java.awt.Font ("Dialog", 0, 11));
          buttonCancel.setLabel("Cancel");
          buttonCancel.setName("button10");
          buttonCancel.setBackground(new java.awt.Color (204, 204, 204));
          buttonCancel.setForeground(java.awt.Color.black);
          buttonCancel.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  buttonCancelActionPerformed(evt);
              }
          }
          );
          panelOK.add(buttonCancel);
          
          
        add(panelOK, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

  private void buttonReadFromFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonReadFromFileActionPerformed
// Add your handling code here:
      //Select a file.
      FileDialog fd = new FileDialog(this.parentFrame,"Select a file",FileDialog.LOAD);
      fd.setVisible(true);
      String fileName = fd.getDirectory() + fd.getFile();
      if (fd.getFile() != null) {
          try {
              //Read the data.
              BufferedReader reader = new BufferedReader(new FileReader(fileName));
              String textLine;
              while ((textLine = reader.readLine()) != null) {
                  this.textAreaEvents.append(textLine + "\n");
              }
              reader.close();
          }
          catch (FileNotFoundException e) {
              System.err.println(e);
          }
          catch (IOException e) {
              System.err.println(e);
          }
      }
  }//GEN-LAST:event_buttonReadFromFileActionPerformed

  private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
// Add your handling code here:
      this.dispose();
  }//GEN-LAST:event_buttonCancelActionPerformed

  private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
// Add your handling code here:
      this.ok = true;
      this.dispose();
  }//GEN-LAST:event_buttonOKActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    public void setAppletType() {
        buttonReadFromFile.setEnabled(false);
    }
    
    public boolean isOK() {
        return ok;
    }
    
    public EventList getEventList() {
/*        boolean[] useField = new boolean[5];
        useField[0] = this.checkboxYear.getState();
        useField[1] = this.checkboxMonth.getState();
        useField[2] = this.checkboxDay.getState();
        useField[3] = this.checkboxHour.getState();
        useField[4] = this.checkboxMinute.getState();
        return new EventList(this.textAreaEvents.getText(),useField);*/
        return new EventList(this.textAreaEvents.getText());
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new EventListDialog (new java.awt.Frame (), true).show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Label labelTitle;
    private java.awt.Panel panelEvents;
    private java.awt.TextArea textAreaEvents;
    private java.awt.Label labelEvents;
    private java.awt.Panel panelOK;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonReadFromFile;
    private java.awt.Button buttonOK;
    private java.awt.Button buttonCancel;
    // End of variables declaration//GEN-END:variables

}
