PRO sedat_read_record_odi, meta, srec, nrec, data, status

  status = 0

  oDB = meta.odi_db

  query = meta.odi_query
  query += " ORDER BY cdf_epoch ASC"
  query += " LIMIT " + STRING(srec-1) + "," + STRING(nrec)

  oRS = OBJ_NEW('IDLDBRecordSet', oDB, N_BUFFERS=100000L, SQL=query)

  status = (oRS->CurrentRecord() GE 0)
  if (status LT 0) THEN error_exit, 'Failed to open record set in sedat_read_record_odi'
  rec = oRS->GetRecord()
  rec = REPLICATE(rec, nrec)

  FOR i=2L,nrec DO BEGIN
    status = oRS->MoveCursor(/NEXT)
    if (status LE 0) THEN error_exit, 'Failed to advance record set in sedat_read_record_odi'
    rec[i-1] = oRS->GetRecord()
  ENDFOR

  OBJ_DESTROY, oRS

; Set the NRV values
  FOR i=0,N_TAGS(meta.nrv_vars)-1 DO $
    data.(meta.nrv_vars.(i).index) = meta.nrv_vars.(i).values

; Load the raw data from the database retrieved records into the required SEDAT dataset structure format:
  nr = 0L
  nfields = N_TAGS(data)
  FOR itag=0,nfields-1 DO BEGIN
    IF (meta.var.(itag).rec_vary) THEN BEGIN
      FOR idim=0,meta.var.(itag).dimensions[0]-1 DO BEGIN   ; loop over the dimensions of the data field
        data[*].(itag)[idim] = rec.(nr)
        nr++  ; move on to the next field in the SQL dataset record
      ENDFOR
    ENDIF
  ENDFOR

END
