#!/usr/bin/php
<?php
/**
* A program to install the cron jobs from the cronjobs.txt file.
* Environment variables are expanded before installed on cron.
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 2 December, 2009 
*
* @version $Id: cronjobs_install.php 223 2009-12-03 12:48:54Z peter $
*
* @package ODI
* @subpackage Admin
*/

$home = getenv("HOME");

$cron_jobs = file("cronjobs.txt");

$cron_file_name = "cronjobs.tmp";

$cron_file = fopen($cron_file_name,"w");

foreach($cron_jobs as $job) {
    $job = trim($job);
    // Skip lines starting with #.
    if(preg_match('/^#/',$job)==0 & strlen($job)>10) {
        $cron_line = trim(preg_replace('/\$HOME/',$home,$job));
        fwrite($cron_file,$cron_line."\n");
    }
}

fclose($cron_file);

exec('crontab '.$cron_file_name);
unlink($cron_file_name);

fwrite(STDOUT,"Installed the following cron jobs:\n");
exec('crontab -l',$res);
foreach($res as $r) {
    fwrite(STDOUT,$r."\n");
}

?>