<?php
/**
* Directory scan functions for the ODI database.
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 2 December, 2009 
*
* @version $Id: dirscan.php 224 2009-12-03 12:49:21Z peter $
*
* @package ODI
* @subpackage Parsers
*/

//////
// Function to build a file list of the specified data directory
//////
  function rfileList($platform, $instrument, $basedir, $filepattern)
  {
    $dfiles = array();

    if ($filepattern == "%dst%")
    {
      if (function_exists("dir_Dst"))
        $dfiles = dir_Dst($basedir, $filepattern);
      else
        print "Function dir_Dst is not declared" . LF;
    }
    else if (strpos($filepattern, "%kpap") !== FALSE)
    {
      if (function_exists("dir_KpAp"))
        $dfiles = dir_KpAp($basedir, $filepattern);
      else
        print "Function dir_KpAp is not declared" . LF;
    }
// Generic directory scan
    else
      $dfiles = dirscan($basedir, $filepattern);

    return $dfiles;
  }

?>