<?php
/**
* Parser function for Sunspot Numbers.
*
* <pre>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* <>          ___  ___  __ _                                        <>
* <>         / _ \/ __|/ _` |               european space agency   <>
* <>        |  __/\__ \ (_| |                                       <>
* <>         \___/\___/\__,_|            agence spatiale europeenne <>
* <>                                                                <>
* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
* </pre>
* The IPR of this software belongs to the European Space Agency. 
* The usage is at the discretion of the Agency and licenses for its 
* use should be addressed to the Contracts Dept. at ESTEC: 
* <pre>
* European Space Agency ESA/ESTEC 
* Contracts Department 
* Postbus 299 
* 2200 AG Noorwijk 
* The Netherlands 
* 
* WEB:         http://www.esa.int/ 
* Phone:         +31 71 565-6565 
* </pre>
* The software was developed under the ESA/ESTEC contract 21964/08/NL/AT by: 
* <pre>
* Peter Wintoft, Swedish Institute of Space Physics and 
* Daniel Heynderickx, DH Consultancy
* </pre>
* 
* Version number: 1.0 
*
* Release Date: 2 December, 2009 
*
* @version $Id: SSN_1m.php 224 2009-12-03 12:49:21Z peter $
*
* @package ODI
* @subpackage ParsersFunctions
*/


// Parse a data file and write formatted content to load.tmp
  function parse_SSN_1m($rname, $fid)
  {
    $ms = 0;
    $ssn = file($rname);
    $tfile = fopen("load.tmp", "w");
    if ($ssn !== FALSE)
    {
      foreach ($ssn as $ssn_row)
      {
        list($year,$month,$y,$s,$s12) = sscanf($ssn_row,"%4d%2d %f %f %f");
        $epoch = sprintf("%04d-%02d-01 00:00:00", $year, $month);
        $cdf_epoch = date_to_cdfepoch($epoch, $ms);

        fprintf($tfile, "%20.3f, %s, %d, %5.1f, %5.1f, %d%s",
                        $cdf_epoch, $epoch, $ms, $s, $s12, $fid, LF);
      }
      fclose($tfile);

      $result = TRUE;
    }
    else
      $result = FALSE;

    return $result;
  }

?>