      IMPLICIT NONE

      INCLUDE 'IRBEM/source/ntime_max.inc'

      INCLUDE 'cdf33_0-dist/src/include/cdf.inc'

C Settings for IRBEM-LIB
      INTEGER*4 KEXT /5/, OPTIONS(5) /1,0,2,0,0/, SYSAXES /1/
C Input values for IRBEM-LIB
      INTEGER*4 IYEAR(NTIME_MAX), IDOY(NTIME_MAX)
      REAL*8 XB1(NTIME_MAX), XB2(NTIME_MAX), XB3(NTIME_MAX)
      REAL*8 DUT(NTIME_MAX), MAGINPUT(25, NTIME_MAX)
C Values returned from IRBEM-LIB
      REAL*8 DL(NTIME_MAX), DL_STAR(NTIME_MAX), DB_CALC(NTIME_MAX)
      REAL*8 DB_EQ(NTIME_MAX), DI(NTIME_MAX), DMLT(NTIME_MAX)

C Internal variables
      INTEGER*4 NREC /1/, NB /0/, IB(NTIME_MAX), MSEC(NTIME_MAX), HR, I
      REAL*8 LAT /0.0D0/, LON, ALT /35793.0D0/, RE /6371.2D0/, DEPOCH
      REAL*8 X1(NTIME_MAX), X2(NTIME_MAX), X3(NTIME_MAX), AEQ, DEGRAD
      CHARACTER*20 CDFEPOCH(NTIME_MAX)
      CHARACTER*19 EPOCH(NTIME_MAX)
      CHARACTER EPOCH_FORMAT*(EPOCHx_FORMAT_MAX)
      CHARACTER EPOCH_ENC*(EPOCHx_STRING_MAX)

      DATA EPOCH_FORMAT /'<year.04>-<doy.03>.<fod.8>'/

      DEGRAD = 45.0D0 / ATAN(1.0D0)

      OPEN (UNIT=1, FILE='epoch.tmp', STATUS='OLD', ERR=9001)
 1001 READ (1,'(A20,2X,A19,1X,I4,1X,F8.2)',END=1002)
     &  CDFEPOCH(NREC), EPOCH(NREC), MSEC(NREC), LON
      CALL GDZ_GEO(LAT, LON, ALT, X1(NREC), X2(NREC), X3(NREC))
      IF (EPOCH(NREC)(15:16) .EQ. '00') THEN
        NB = NB + 1
        XB1(NB) = X1(NREC)
        XB2(NB) = X2(NREC)
        XB3(NB) = X3(NREC)
        READ (CDFEPOCH(NREC), *) DEPOCH
        CALL encode_EPOCHx(DEPOCH, EPOCH_FORMAT, EPOCH_ENC)
        READ (EPOCH_ENC, '(I4,1X,I3,F9.8)')
     &    IYEAR(NB), IDOY(NB), DUT(NB)
        DUT(NB) = DUT(NB) * 24.0D0
      END IF
      IB(NREC) = NB
      NREC = NREC + 1
      GO TO 1001
 1002 CONTINUE
      CLOSE (1)
      NREC = NREC - 1

C Use IRBEM-LIB to calculate the magnetic field coordinates
      CALL MAKE_LSTAR1(NB, KEXT, OPTIONS, SYSAXES,
     &                 IYEAR, IDOY, DUT, XB1, XB2, XB3, MAGINPUT,
     &                 DL, DL_STAR, DB_CALC, DB_EQ, DI, DMLT)

      OPEN (UNIT=2, FILE='position.tmp', STATUS='UNKNOWN', ERR=9002)
      DO I=1,NREC
        IF (DB_CALC(IB(I)) .LT. DB_EQ(IB(I))) THEN
          AEQ = 90.0D0
        ELSE
          AEQ = DEGRAD * ASIN(SQRT(DB_EQ(IB(I))/DB_CALC(IB(I))))
        END IF
        WRITE (2,'(A,2H, ,A,1H,,I4,3(1H,,F12.3),1P,8(1H,,E14.6),0P)')
     &    CDFEPOCH(I), EPOCH(I), MSEC(I), X1(I)*RE, X2(I)*RE, X3(I)*RE,
     &    DB_CALC(IB(I)), DB_EQ(IB(I)), DI(IB(I)), DL(IB(I)),
     &    DL_STAR(IB(I)), DMLT(IB(I)), 90.0D0, AEQ
      END DO
      CLOSE(2)

      STOP ' '
C
C Error exits
C
 9001 STOP 'Error opening epoch file'
 9002 STOP 'Error opening position file'

      END